﻿var UI_NUM_PLANETS = 9;

var STARDATE_TRAITS = [
  { 
    'name' : strings.DATE_TYPE_TNG,
    'epoch' : new Date(2323, 0, 1).getTime(),
    'unit' : 31556952, 
    'issue' : 21,
    'width' : 5,
    'modulus' : 100000
  },
  { 
    'name' : strings.DATE_TYPE_TOS,
    'epoch' : new Date(2162, 0, 4).getTime(),
    'unit' : 17280000, 
    'issue' : 0,
    'width' : 4,
    'modulus' : 10000
  }
];

var UI_NEW_PLANET_INTERVAL = 4000;

var UI_PLANET_ANIMATION_DURATION = 1000;

options.defaultValue('sd_type') = 0; 
options.defaultValue('sd_with_issue') = false;
options.defaultValue('sd_with_time') = true;

pluginHelper.onAddCustomMenuItems = MAIN_menuAddCustomItems;

function MAIN_createOptionSetter(name, value) {
  return function () {
    options.PutValue(name, value);
    MAIN_dateUpdate();
    RSS_updateDisplay();
  };
}


function _MAIN_viewOnOpen() {
  view.setInterval(MAIN_planetCycle, UI_NEW_PLANET_INTERVAL);
  view.setInterval(MAIN_dateUpdate, 1000);
  MAIN_dateUpdate();
  
  RSS_start();
}

var MAIN_planetIndex = 0;

function MAIN_planetCycle() {
  MAIN_planetIndex = (MAIN_planetIndex + 1) % UI_NUM_PLANETS;
  
  view.beginAnimation(MAIN_planetFade, 0, 255, UI_PLANET_ANIMATION_DURATION);
}

function MAIN_planetFade() {
  
  if (event.value == 255) {
    planet.src = planet_overlay.src;
    
  }
}

function MAIN_zeroPadString(str, length) {
  while (str.length < length) {
    str = '0' + str;
  }
  return str;
}

function MAIN_starDate(now, timeSep, lineSep) {
  var traits = STARDATE_TRAITS[options.GetValue('sd_type')];
  
  var rawSD = (now.getTime() - traits.epoch) / traits.unit;
  
  var mod = traits.modulus;
  
  var issue = traits.issue + Math.floor(rawSD / mod);

  var sd = rawSD % mod;
  if (sd < 0) {
    sd += mod;
  }
  
  var issue = options.GetValue('sd_with_issue') ?
      '[' + issue + ']' + lineSep : '';
  var stardate = MAIN_zeroPadString(sd.toFixed(2), traits.digits + 3);
  var time = options.GetValue('sd_with_time') ? lineSep +
      MAIN_zeroPadString(now.getHours().toString(), 2) + timeSep +
      MAIN_zeroPadString(now.getMinutes().toString(), 2) : '';
  
  return issue + stardate + time;
}

var MAIN_timeSep = '';

function MAIN_dateUpdate() {
  MAIN_timeSep = (MAIN_timeSep == ':') ? String.fromCharCode(160) : ':';
  
  var sd = MAIN_starDate(new Date(), MAIN_timeSep, '\r\n');
}

function onSize() {
  entryList.resize(view.width, view.height);
}