﻿var RSS_ITEMS_DISPLAYED = 14;
var RSS_ITEM_HEIGHT = 27;
var RSS_FEED_URLS = [
  'http://blog.dealrocker.com/dr/rss.xml'
];

var RSS_DATE_REGEXP = /^(\d{2})\/(\d{2})\/(\d{2})$/;

var URL_PREFIX = 'http://dealrocker.com/';
var FEED_TITLE = 'DealRocker';

var RSS_REFRESH_INTERVAL = 1800000;

var RSS_currentFeed;

var RSS_req = null;

var RSS_currentItems;

function enterSearch () {
	if (searchinput.value == 'Search for Deals') searchinput.value = '';
}

function exitSearch () {
	if (searchinput.value == '') searchinput.value = 'Search for Deals';
}

function getSearch () {
	if (searchinput.value == '' || searchinput.value == 'Search for Deals') {
		searchinput.focus();
	} else openSite('http://www.dealrocker.com/search-deals?text='+fullEscape(searchinput.value));
	return false;
}
function fullEscape (theString) {
	theString = escape(theString);
	theString = theString.replace('+','%2B');
	return theString;
}

function getStores()
{
openSite('http://www.dealrocker.com/stores');
}
function getDeals()
{
openSite('http://www.dealrocker.com/deals');
}
function getPrintables()
{
openSite('http://www.dealrocker.com/online-coupons/');
}
function openSite (theUrl) {
	var winShell = new ActiveXObject("Shell.Application");
	winShell.ShellExecute(theUrl); 
	return false;
}

function RSS_start() {
  for (var i = 0, y = 0; i < RSS_ITEMS_DISPLAYED; i++, y += RSS_ITEM_HEIGHT) {
    var el = news.appendElement('<div x="0" width="100%" />');
    el.y = y;
    el.height = RSS_ITEM_HEIGHT - 2;
    el.appendElement('<img x="12" y="1" src="color_block.png"/>');
	el.appendElement('<a x="22" y="0" width="210" height="28"' +
      ' font="Arial" size="7.5" wordWrap="true" bold="true"' +
      ' color="#003300" underline="false" overColor="#206002" />');
    
  }
  
  view.setInterval(RSS_refresh, RSS_REFRESH_INTERVAL);
  RSS_refresh();

  RSS_updateDisplay();
}

function RSS_refresh() {
  RSS_currentItems = [];
  
  RSS_currentFeed = 0;
  RSS_startRequest();
}

function RSS_startRequest() {
  if (RSS_req !== null) {
    try {
      RSS_req.abort();
      RSS_req = null;
    } catch(e) {
    }
  }
  
  while (RSS_currentFeed < RSS_FEED_URLS.length) {
    RSS_req = new XMLHttpRequest();
    RSS_req.onreadystatechange = RSS_onReadyStateChange;
    
    try {
      RSS_req.open('GET', RSS_FEED_URLS[RSS_currentFeed], true);
      RSS_req.send();
      
      break;
    } catch(e) {
      RSS_currentFeed++;
    }
  }
}

function RSS_onReadyStateChange() {
  if (RSS_req.readyState == 4) {
    RSS_parse(RSS_req.responseXML);
    RSS_req = null;
    
    RSS_currentFeed++;
    RSS_startRequest();
  }
}

function RSS_getChild(el, name) {
  var els = el.getElementsByTagName(name);
  return els.length > 0 ? els[0].text : null;
}

function RSS_itemSort(a, b) {
  if (a.pubDate != b.pubDate) {
    return b.pubDate - a.pubDate;
  } else if (a.feedTitle < b.feedTitle) {
    return -1;
  } else if (a.feedTitle > b.feedTitle) {
    return 1;
  } else {
    return 0;
  }
}

function RSS_parseDate(str) {
  var date = Date.parse(str);
  if (isNaN(date)) {
    var m = str.match(RSS_DATE_REGEXP);
    if (m) {
      date = new Date(2000 + Number(m[3]),
        Number(m[1]) - 1, Number(m[2])).getTime();
    } else {
      date = 0;
    }
  }
  return date;
}

function RSS_FeedItem(feedTitle, feedLink, item) {
  this.feedTitle = feedTitle;
  this.feedLink = feedLink;
  
  this.title = RSS_getChild(item, 'title');
  this.link = RSS_getChild(item, 'link');
  this.pubDate = RSS_parseDate(RSS_getChild(item, 'pubDate'));
}

function RSS_parse(doc) {
  var channel = null, feedTitle = null, feedLink = null;
  
  var channels = doc.getElementsByTagName('channel');
  if (channels.length < 1) {
    return;
  }
  
  channel = channels[0];
  feedTitle = RSS_getChild(channel, 'title');
  feedLink = RSS_getChild(channel, 'link');
  
  if (channel == null || feedTitle === null || feedLink === null) {
    return;
  }
  
  if (RSS_FEED_URLS[RSS_currentFeed].substr(0, URL_PREFIX.length)
      === URL_PREFIX) {
    feedTitle = FEED_TITLE;
  }
  
  var e = new Enumerator(channel.getElementsByTagName('item'));
  for (e.moveFirst(); !e.atEnd(); e.moveNext()) {
    var item = e.item();
    
    RSS_currentItems.push(new RSS_FeedItem(feedTitle, feedLink, item));
  }
  
  RSS_currentItems.sort(RSS_itemSort);
  
  RSS_currentItems.length = RSS_ITEMS_DISPLAYED;
  
  RSS_updateDisplay();
}
function RSS_updateDisplay() {
  var cls = news.children;
  for (var i = 0; i < RSS_ITEMS_DISPLAYED; i++) {
    var el = cls.item(i);
    var item = RSS_currentItems[i];
    
    if (item !== undefined) {
      var link = el.children.item(1);
      var title = ENT_htmlDecode(item.title);
      link.innerText = title;
      link.tooltip = title;
      link.href = item.link ? item.link : '';
      
       el.visible = true;
    } else {
      el.visible = false;
    }
  }
}
function searchFocus() {
	if (searchinput.value == 'Search for Coupons/Deals') searchinput.value = '';
}

function searchBlur() {
	if (searchinput.value == '') searchinput.value = 'Search for Coupons/Deals';
}
function keyPress() {
	if(event.keyCode == 13) {
		getSearch();
	}
}
